"""
Module to calculate RTT
:author: gurnoorsingh (20221024)
"""

import re
import time
import requests
import subprocess
import numpy as np

def myping(host, num=10):
    command = f"sudo ping -f -c {num} -W 0.5 {host}"
    with subprocess.Popen(command, stdout=subprocess.PIPE, stderr=None, shell=True) as process:
        output = process.communicate()[0].decode("utf-8")

    results = re.findall(".*min/avg/max/mdev = (.*?) ms", output)[0]
    avg_rtt = float(results.split('/')[1])
    return int(avg_rtt * 1e6)

 
def RTT(url):
    times = []
    num_iterations = 10

    for _ in range(num_iterations):
        t1 = time.time()
        _ = requests.get(url)
        t2 = time.time()
        times.append((t2 - t1))
 
    return int(np.mean(times) * 1e9)
 
def main():
    # url address
    url = "http://oregong-algorand-test-1.algorand-testnet.network:4161"
    url = "londong-algorand-test-2.algorand-testnet.network"
    url = "singaporeg-algorand-test-1.algorand-testnet.network"
    print(myping(url))

if __name__ == '__main__':
    main()