"""
Module to process log file for received messages from relays
:author: gurnoorsingh (20221024)
"""
import re
import json
from RTT import myping


def get_txn_receiver_stats(txn_id):
    send_time_values = dict()
    filename = f"/home/azureuser/algorand-topology/filtered_logs/data_{txn_id}"

    MSG_RECEIVED_IDENTIFIER = "got a tx group with IDs"

    with open(filename) as fh:
        for line in fh.readlines():
            try:
                row = json.loads(line)
            except:
                continue
            if row["msg"].startswith(MSG_RECEIVED_IDENTIFIER):
                txn_ids_str = re.findall(f".*{MSG_RECEIVED_IDENTIFIER} \[(.*?)\].*", row["msg"])[0]
                txn_ids = [x.strip() for x in txn_ids_str.split()]

                assert txn_id in txn_ids

                sender = re.findall(".*rootURL:(.*?)\s.*", row["msg"])[0]
                recv_time = int(re.findall(".*at.*?([0-9]+) with data.*", row["msg"])[0])
                txn_size = len(re.findall(".*uint8=\[(.*?)\]", row["msg"])[0].split())

                try:
                    send_time = recv_time - myping(f"{sender.split(':')[0]}")//2
                    send_time_values[sender] = send_time
                except Exception as e:
                    print(e, sender)
        
    return send_time_values

def main():
    print(get_txn_receiver_stats("ESSEGXUEITTMHO4SI37W6BNBUYHHQQE4YNORJ7TEA5VX6ISJDWAA"))

if __name__ == '__main__':
    main()


# TXN_ID = "F7CCM55MJB7FBW5G37MKQLF34Z75M3ZKUDTR7STZC2YHFO6YQOUA"
# send_times = []
# for k, v in tx_senders_map.items():
#     if k == TXN_ID:
#         for sender, recv_time in v:
#             send_time = recv_time - RTT(f"http://{sender}")//2
#             print(f"Received time: {recv_time}\nSend time: {send_time}")
#             send_times.append((sender, send_time))

# send_times.sort(key=lambda x: x[1])
# print(send_times)
